from CvPythonExtensions import *

gc = CyGlobalContext()

class SettlersEventManager:
	def __init__(self, eventManager):
		eventManager.addEventHandler("cityBuilt", self.onCityBuilt)

	def onCityBuilt(self, argsList):
		'City Built'
		city = argsList[0]

		pUnit = CyInterface().getHeadSelectedUnit()
		if pUnit:
			if pUnit.getUnitClassType() == gc.getInfoTypeForString("UNITCLASS_SETTLER"):
				## Do Nothing
				pass

			elif pUnit.getUnitClassType() == gc.getInfoTypeForString("UNITCLASS_COLONIST"):
				city.setPopulation(2)
				_addBuilding(city, "BUILDINGCLASS_BARRACKS")
				_addBuilding(city, "BUILDINGCLASS_GRANARY")
				if city.plot().isCoastalLand():
					_addBuilding(city, "BUILDINGCLASS_HARBOR")
					_addBuilding(city, "BUILDINGCLASS_LIGHTHOUSE")

			elif pUnit.getUnitClassType() == gc.getInfoTypeForString("UNITCLASS_PIONEER"):
				city.setPopulation(3)
				_addBuilding(city, "BUILDINGCLASS_BARRACKS")
				_addBuilding(city, "BUILDINGCLASS_GRANARY")
				_addBuilding(city, "BUILDINGCLASS_COURTHOUSE")
				_addBuilding(city, "BUILDINGCLASS_MARKET")
				_addBuilding(city, "BUILDINGCLASS_STABLE")
				_addBuilding(city, "BUILDINGCLASS_GROCER")
				if city.plot().isCoastalLand():
					_addBuilding(city, "BUILDINGCLASS_HARBOR")
					_addBuilding(city, "BUILDINGCLASS_LIGHTHOUSE")

			elif pUnit.getUnitClassType() == gc.getInfoTypeForString("UNITCLASS_ARCHITECT"):
				_addBuilding(city, "BUILDINGCLASS_BARRACKS")
				_addBuilding(city, "BUILDINGCLASS_GRANARY")
				_addBuilding(city, "BUILDINGCLASS_COURTHOUSE")
				_addBuilding(city, "BUILDINGCLASS_MARKET")
				_addBuilding(city, "BUILDINGCLASS_STABLE")
				_addBuilding(city, "BUILDINGCLASS_GROCER")
				_addBuilding(city, "BUILDINGCLASS_AQUEDUCT")
				_addBuilding(city, "BUILDINGCLASS_BANK")
				_addBuilding(city, "BUILDINGCLASS_FORGE")
				_addBuilding(city, "BUILDINGCLASS_LIBRARY")
				_addBuilding(city, "BUILDINGCLASS_JAIL")
				_addBuilding(city, "BUILDINGCLASS_OBSERVATORY")
				_addBuilding(city, "BUILDINGCLASS_THEATRE")
				if city.plot().isCoastalLand():
					_addBuilding(city, "BUILDINGCLASS_HARBOR")
					_addBuilding(city, "BUILDINGCLASS_LIGHTHOUSE")


def _addBuilding(pCity, szBuilding):
	iBuilding = gc.getInfoTypeForString(szBuilding)
	iUniqueBuilding = gc.getCivilizationInfo(gc.getPlayer(pCity.getOwner()).getCivilizationType()).getCivilizationBuildings(iBuilding)
	if iUniqueBuilding > -1:
		if pCity.canConstruct(iUniqueBuilding, False, True, False):
			pCity.setHasRealBuilding(iUniqueBuilding, True)		